SuperStrict

Framework brl.glmax2d
Import brl.timer
Import brl.system
Import brl.retro
Import brl.stream
Import brl.pngloader
Import brl.pixmap
Import brl.GLGraphics

Const gfx_w%=800
Const gfx_h%=600
Const hertz%=60
Const maxlooptime#=1000.0/Float(hertz)
Const cursorsize%=14

Global level%
Global levelstarttime%
Global leveltime%

Global ms%

Global mx%, my%
Global oldmx%, oldmy%
Global mhit_l%

Global menucolors%[][]

Global img_menu:TImage
Global img_klicken:TImage
Global img_level:TImage
Global img_ziffern:TImage
Global img_gameover:TImage
Global img_bg:TImage

Global levellist:TList

Global autoX%, autoY%




AppTitle="60 sek survival"
Graphics gfx_w, gfx_h, 0, hertz, 2

AutoMidHandle True
img_menu=LoadAnimImage("gfx\menu.png", 380, 100, 0, 6)
img_gameover=loadimage("gfx\gameover.png")
img_klicken=loadimage("gfx\klicken.png")

AutoMidHandle False
img_ziffern=LoadAnimImage("gfx\ziffern.png", 40, 60, 0, 10)
img_level=loadimage("gfx\level.png")


Local color%[][]=[[0,16,32], [0,16,0], [32,16,0]]

img_bg=CreateImage(gfx_w, gfx_h)
Local pixmap:TPixmap=LockImage(img_bg)
If color.length=1 Then
	ClearPixels pixmap, color[0][0]*$10000+color[0][1]*$100+color[0][3]
Else
	For Local i%=0 To color.length-2
		For Local y%=gfx_h/(color.length-1)*i To gfx_h/(color.length-1)*(i+1)-1
			Local f#=(y-gfx_h/(color.length-1)*i) / Float(gfx_h/(color.length-1)-1)
			Local r%=Max(Min(color[i][0]*(1-f)+color[i+1][0]*f,$FF),0)
			Local g%=Max(Min(color[i][1]*(1-f)+color[i+1][1]*f,$FF),0)
			Local b%=Max(Min(color[i][2]*(1-f)+color[i+1][2]*f,$FF),0)
			Local argb%=$FF000000+r*$10000+g*$100+b
			For Local x%=0 To gfx_w-1
				WritePixel pixmap, x, y, argb
			Next		
		Next
	Next
EndIf
UnlockImage img_bg

HideMouse

menucolors=[[231,224,123], [148, 238, 198], [175, 134, 231]]
	
	
	

Local timer:TTimer=CreateTimer(hertz)

Local state%=0


While Not (AppTerminate() Or KeyHit(KEY_ESCAPE))
	ms=MilliSecs()

	oldmx=mx
	oldmy=my
	mx=MouseX()
	my=MouseY()
	
	mhit_l=MouseHit(1)
	
	Cls 
	
	Select state
		Case 0
			SetNormalDrawingModes()
			Local w%=ImageWidth(img_menu)
			Local h%=ImageHeight(img_menu)
			DrawImage img_bg, 0, 0
			For Local i%=0 To 2
				SetColor menucolors[i][0], menucolors[i][1], menucolors[i][2]
				ResetCollisions 1
				CollideRect gfx_w/2 -w/2, gfx_h/2 +(i-1)*150-h/2, w, h, 0, 1
				If CollideRect(mx, my, 1, 1, 1, 0) Then
					DrawImage img_menu, gfx_w/2, gfx_h/2 +(i-1)*150, i*2+1
					If mhit_l Then
						Select i
							Case 0
								level=1
								state=1
							Case 1; OpenURL("readme.txt")
							Case 2; End 
						End Select
					EndIf	
				Else
					DrawImage img_menu, gfx_w/2, gfx_h/2 +(i-1)*150, i*2
				EndIf
			Next
		Case 2
			
			Local oldleveltime%=leveltime
			leveltime=Min(ms-levelstarttime, 60000)
			Local speedfaktor%=leveltime-oldleveltime
			
			For Local seq:TSequence=EachIn levellist
				Local start%=seq.ints[0]
				Local ende%=seq.ints[1]
				Local prog#=(leveltime-start)*1.0/(ende-start)
				If prog<0 Or prog>1 Then prog=0
				
				If start=ende And start<leveltime And seq.done=False Then
					prog#=1
					seq.done=True
				EndIf
				If prog Then
					For Local i%=0 To 2 Step 2
						If seq.floats[0+i]=-1 Then seq.floats[0+i]=autoX
						If seq.floats[1+i]=-1 Then seq.floats[1+i]=autoY
					Next
					
					Local x#=seq.floats[0]*(1-prog)+seq.floats[2]*prog
					Local y#=seq.floats[1]*(1-prog)+seq.floats[3]*prog
					Local w#=seq.ints[2]*(1-prog)+seq.ints[4]*prog
					Local h#=seq.ints[3]*(1-prog)+seq.ints[5]*prog
					
					Local winkel#, size#=1
					Local length1%=seq.ints[6]
					Local length2%=seq.ints[7]
					Local argb%=seq.ints[10]
					
					SeedRnd seq.ints[8]
					
					SetNormalDrawingModes()
					SetColor (argb & $FF0000)/$10000, (argb & $FF00)/$100, argb & $FF
					If seq.ints[9] & 32 Then
						autoX=mx
						autoY=my
						Continue
					EndIf
					If seq.ints[9] & 64 Then SetAlpha prog
					If seq.ints[9] & 2 Then
						x=x+autox
						y=y+autoy
					EndIf
					If seq.ints[9] & 8 Then SetBlend LIGHTBLEND
					If seq.ints[9] & 4 Then
						size=Min( Min((leveltime-start)/500.0, (ende-leveltime)/500.0) , 1)
						SetAlpha size
						winkel=ATan2(mx-seq.floats[0]-w/2*size, my-seq.floats[1]-h/2*size)+seq.floats[4]
						seq.floats[0]=seq.floats[0]+Sin(winkel)*seq.floats[5]*speedfaktor
						seq.floats[1]=seq.floats[1]+Cos(winkel)*seq.floats[5]*speedfaktor
						seq.floats[2]=seq.floats[0]
						seq.floats[3]=seq.floats[1]
					Else 
						SetRotation seq.floats[4]
					EndIf 
					If seq.ints[9] & 16 Then 
						winkel=Rnd(0,360) 
						Local bis%=prog*(length1+length2)
						For Local k%=0 To bis
							If k=>bis-length2 And k<=length1 Then 
								SetColor 0,0,0
								DrawOval x-w/2, y-h/2, w, h
								autox=x
								autoy=y
							EndIf
							If k=Min(length1,bis)  Then
								SetColor 128,128,128
								DrawOval x-w/2+2, y-h/2+2, w-4, h-4
							EndIf 
							winkel=winkel+Rnd(-12, 12)
							Local newx#=x+Sin(winkel)*2
							Local newy#=y+Cos(winkel)*2
							If newx>gfx_w-w/2 Or newx<w/2 Then
								winkel=ATan2(-Sin(winkel), Cos(winkel))
							ElseIf newy>gfx_h-h/2 Or newy<h/2 Then
								winkel=ATan2(Sin(winkel), -Cos(winkel))
							Else 
								x=newx
								y=newy
							EndIf
						Next
					ElseIf seq.ints[9] & 1 Then
						DrawOval x, y, w*size, h*size
					Else
						drawrect x, y, w*size, h*size
					EndIf
					SetScale 3,3
					SetColor 0, 0, 128
					DrawText seq.text, x+w/2-Len(seq.text)*12, y+h/2-30
				EndIf
			Next
			
			SetNormalDrawingModes()
			SetColor 128,128,128	
			Local str$=leveltime/1000.0
			Local point%=Instr(str$, ".")
			DrawText Left(str, point+3)+"sek", 5, 5
	
			Local cx%=Min(mx,oldmx)
			Local cy%=Min(my,oldmy)
			Local cw%=mx-oldmx
			Local ch%=my-oldmy
			Local cm%=1
			
			If leveltime>=60000 Then
				If FileType("level"+(level+1)+".lev")<>1 Then
					Flip 0
					Notify "Es scheint kein weiteres Level mehr da zu sein. Du hast gewonnen!"
					state=0
				Else
					level=level+1
					state=1
				EndIf
			EndIf
	
			
			If cw<0 Then
				cw=-cw
				cm=cm*-1
			EndIf
			If ch<0 Then
				ch=-ch
				cm=cm*-1
			EndIf
			Local pixmap:TPixmap=GrabPixmap(cx,cy,cw+1,ch+1)
			If cw>ch Then
				For Local x%=0 To cw
					Local y%
					If cw=0 Then 
						y=0
					Else
						y%=x*ch/cw*cm+(cm=-1)*ch
					EndIf
					Local color%=ReadPixel(pixmap, x, y) & $00FFFFFF
					If color=$FFFFFF Then
						mx=cx+x
						my=cy+y
						DrawGOScreen()
						state=0
						Exit 
					EndIf
				Next
			Else
				For Local y%=0 To ch
					Local x%
					If ch=0 Then
						x=0
					Else
						x=y*cw/ch*cm+(cm=-1)*cw
					EndIf
					Local color%=ReadPixel(pixmap, x, y) & $00FFFFFF
					If color=$FFFFFF Then
						mx=cx+x
						my=cy+y	
						DrawGOScreen()
						state=0
						Exit 
					EndIf
				Next
			EndIf
		Case 1
			Local levelstr$=String(level)
			Local levelstrlen%=Len(levelstr)
			SetNormalDrawingModes()
			DrawImage img_bg, 0, 0
			DrawImage img_level, gfx_w/2-(ImageWidth(img_level)+30+ImageWidth(img_ziffern)*(levelstrlen))/2, gfx_h/2-ImageHeight(img_level)/2
			For Local i%=1 To levelstrlen
				DrawImage img_ziffern, gfx_w/2 - ImageWidth(img_ziffern)*(levelstrlen-(i-1)*2)/2..
					+(ImageWidth(img_level)+30)/2, gfx_h/2-ImageHeight(img_level)/2,..
					Int(Mid(levelstr, i, 1))
			Next
			DrawImage img_klicken, gfx_w/2, gfx_h-ImageHeight(img_klicken)
			If mhit_l Then
				levellist=TSequence.readLevel("level"+level+".lev")
				levelstarttime=MilliSecs()
				state=2
			EndIf
	End Select 
	
	DrawCursor(mx, my)
	
	Flip 0
	
	WaitTimer timer
Wend

Function SetNormalDrawingModes()
	SetColor 255, 255, 255
	SetClsColor 0,0,0
	SetScale 1, 1
	SetRotation 0
	SetAlpha 1
	SetBlend ALPHABLEND
End Function

Function DrawCursor(x%,y%)
	SetNormalDrawingModes()
	SetColor 255, 128, 0
	drawrect x, y-cursorsize, 1, cursorsize/2
	drawrect x, y+cursorsize/2, 1, cursorsize/2
	drawrect x-cursorsize, y, cursorsize/2, 1
	drawrect x+cursorsize/2, y, cursorsize/2, 1  
	SetColor 64,128,255
	Plot x, y
End Function


Function DrawGOScreen%()
	SetNormalDrawingModes()
	DrawImage img_gameover, gfx_w/2, gfx_h/2
	DrawImage img_klicken, gfx_w/2, gfx_h-ImageHeight(img_klicken)
	DrawCursor(mx, my)
	ShowMouse()
	Flip 0
	Cls 
	Repeat
		If MouseHit(1) Then Exit
		If AppTerminate() Or KeyHit(KEY_ESCAPE) Then End
		Delay 50
	Forever
	HideMouse()
	ms=MilliSecs()
End Function

Type TSequence
'	Field time1%, time2% 0, 1
'	Field pos1x#, pos1y# 0, 1
'	Field pos2x#, pos2y# 2, 3
'	Field size1w%, size1h% 2, 3
'	Field size2w%, size2h% 4, 5
'	Field length1%, length2% 6, 7
'	Field srnd% 8
	Field text$
'	Field winkel# 4
'	Field form% 9
'	Field farbe% 10
'	Field speed# 5
'	Field autocoords% 11
	Field image:TImage
	Field done%=0 
'	
'	Global gtime1%, gtime2%
'	Global gpos1x#, gpos1y#
'	Global gpos2x#, gpos2y#
'	Global gsize1w%, gsize1h%
'	Global gsize2w%, gsize2h%
'	Global glength1%, glength2%
'	Global gsrnd%
	Global gtext$
'	Global gwinkel#
'	Global gform%
'	Global gfarbe%
'	Global gspeed#
'	Global gautocoords%
	
	Field ints%[12]
	Field floats#[6]
	
	Global gints%[13]
	Global gfloats#[6]
	
	Function ReadLevel:TList(filename$)
		Local file:TStream=ReadStream(filename$)
		Local list:TList=New TList
		While Not Eof(file)
			list.AddLast(New TSequence.ReadFromFile(file))
		Wend
		CloseStream file
		Return list
	End Function
	
	Method ReadFromFile:TSequence(file:TStream)
		Repeat
			Local head:Byte=ReadByte(file)
			If head<128 Then Exit
			Select head-128
				Case 0
					gints[0]=ReadShort(file)
					gints[1]=ReadShort(file)
				Case 1
					gfloats[0]=ReadSignedShort(file)
					gfloats[1]=ReadSignedShort(file)
					gfloats[2]=gfloats[0]
					gfloats[3]=gfloats[1]
				Case 2
					gfloats[2]=ReadSignedShort(file)
					gfloats[3]=ReadSignedShort(file)
				Case 3
					gints[2]=ReadShort(file)
					gints[3]=ReadShort(file)
					gints[4]=gints[2]
					gints[5]=gints[3]
				Case 4
					gints[4]=ReadShort(file)
					gints[5]=ReadShort(file)
				Case 5
					gints[9]=ReadByte(file)
					gtext$=ReadByteString(file)
					gints[10]=ReadInt(file)
				Case 6
					gfloats[4]=ReadFloat(file)
				Case 7
					gfloats[5]=ReadFloat(file)
				Case 8
					gints[11]=True
				Case 9
					gints[11]=False
				Case 10
					gints[6]=ReadShort(file)
					gints[7]=ReadShort(file)
				Case 11
					gints[8]=ReadByte(file)
			End Select
		Until Eof(file)
		Local i%
		For i=0 To 11
			ints[i]=gints[i]
		next
		For i=0 To 5
			floats[i]=gfloats[i]
		Next 
		text=gtext
		
		Return Self
	End Method
End Type

Function ReadSignedShort%(file:TStream)
	Return ReadShort(file)-2^15 
End Function

Function ReadByteString$(file:TStream)
	Local l%=ReadByte(file)
	Return ReadString(file, l)
End Function