'Find It! - BCC #37 - Kernle - v1.05
'=================================================
SuperStrict
'=================================================

Framework BRL.Graphics
	Import BRL.LinkedList
	Import BRL.Random
	Import BRL.GLMax2D
	Import BRL.FreeTypeFont
	Import BRL.PNGLoader
	Import BRL.Timer

SeedRnd(MilliSecs())

'=================================================

Global _GraphicsWidth:Int = 800
Global _GraphicsHeight:Int = 600
Global Hertz:Int = 60

'=================================================

If AppArgs.Length > 2 Then _GraphicsWidth = AppArgs[1].ToInt() ; _GraphicsHeight = AppArgs[2].ToInt()
If AppArgs.Length > 3 Then Hertz = AppArgs[3].ToInt()

'=================================================

Const roundtime:Int = 60000

'=================================================

AppTitle = "Find It! - BCC #37 - Kernle - v1.05"
Graphics _GraphicsWidth,_GraphicsHeight
SetBlend(ALPHABLEND)

'=================================================

Global LangWord:TGameWord, LangList:TList
Global finishtime:Int, playerpoints:Int, gEnd:Byte, skips:Int
Global flashtimer:Float, flashcolor:Int

Global Difficultys:TImage[3],CounterArrow:TImage = LoadImage("Row.png",MASKEDIMAGE),Clipboard:TImage = LoadImage("Clipboard.png",FILTEREDIMAGE+MIPMAPPEDIMAGE),Title:TImage = LoadImage("Title.png")
Global font1:TImageFont = LoadImageFont("arial.ttf",16),font2:TImageFont = LoadImageFont("arial.ttf",80)
Global FPSTimer:TTimer = CreateTimer(Hertz)
Global ClockImage:TImage = LoadImage("Clock.png")

SetImageHandle(CounterArrow,1,ImageHeight(CounterArrow))
SetImageFont(font1)

For Local I:Int = 0 To 2
	Difficultys[I] = LoadImage("Dif"+I+".png")
Next

'=================================================

'FPS Bremse
AddHook FlipHook,waithook
Function waithook:Object(id:Int,data:Object,context:Object)
	If FPSTimer Then FPSTimer.Wait()
End Function

'=================================================

Repeat
	Cls
	
	DrawImage(Title,_GraphicsWidth/2 - 196/2,70)
	
	Local xcord:Int = _GraphicsWidth/2 - 224/2
	
	DrawImage(Difficultys[0],xcord,200)
	DrawImage(Difficultys[1],xcord,300)
	DrawImage(Difficultys[2],xcord,400)
	
	If MouseHit(1)
		If NumBewteen(MouseX(),xcord,xcord + 224) And NumBewteen(MouseY(),200,274)
			Game(0,5,10)
		ElseIf NumBewteen(MouseX(),xcord,xcord + 224) And NumBewteen(MouseY(),300,374)
			Game(3,7,12)
		ElseIf NumBewteen(MouseX(),xcord,xcord + 224) And NumBewteen(MouseY(),400,474)
			Game(5,-1,15)
		ElseIf NumBewteen(MouseX(),0,10) And NumBewteen(MouseY(),0,10)
			Game(0,-1)
		EndIf
	EndIf
	
	If KeyHit(KEY_ESCAPE) Then Return
	If AppTerminate() Then End
	
	Flip 0
Forever

Function Game(difficulty:Int,difficulty2:Int,maxwords:Int=-1)
	ReadLangFile(difficulty,difficulty2,maxwords)
	
	finishtime = MilliSecs() + roundtime
	flashtimer = 1.0
	flashcolor = 0
	playerpoints = 0
	gEnd = 0
	skips = 0
	
	Repeat
		Cls
		
		'---------
		
		Local height:Int = _GraphicsHeight-TextHeight(LangWord.Difficulty)
		
		DrawText("Suche nach diesem Wort: " + LangWord.Content,0,height-TextHeight(LangWord.Content))
		DrawText("Punkte fr das Wort: " + LangWord.Difficulty,0,height)
		
		height = _GraphicsHeight-TextHeight(playerpoints)
		DrawText("Wrter brig: "+LangList.Count(),_GraphicsWidth-TextWidth("Wrter brig: "+LangList.Count()),height-TextHeight(LangList.Count()))
		DrawText("Punktestand: "+playerpoints,_GraphicsWidth-TextWidth("Punktestand: "+playerpoints),height)
		
		'---------
		
		DrawField()
		DrawClock(finishtime-MilliSecs())
		
		If MouseHit(2) And Not LangList.IsEmpty()
			SelectNextWord()
			flashtimer = MilliSecs()+700
			flashcolor = 0
			skips:+1
		EndIf
		
		If LangWord = Null Then gEnd = 1 Exit
		If MilliSecs() > finishtime Then gEnd = 2 Exit
		
		'---------
		
		Select flashcolor
			Case 1 SetColor 255,0,0
			Case 2 SetColor 0,255,0
		End Select
		
		SetAlpha(Max(0,Float(flashtimer-MilliSecs())/700)) DrawRect(0,0,_GraphicsWidth,_GraphicsHeight)
		SetAlpha(1) SetColor 255,255,255
		
		'---------
		
		If KeyHit(KEY_ESCAPE) Then Return
		If AppTerminate() Then End
		
		'---------
		
		Flip 0
	Forever
	Score(finishtime)
End Function

Function Score(finishtime:Int)
	Local timer:TTimer = CreateTimer(1)
	Local fintime:Int = Max(finishtime-MilliSecs(),0)/10 'Sekunden * 100
	Local perfect:Byte = (gEnd=1) And (skips=0)
	Local counter:Int
	
	SetColor 255,255,255
	
	Repeat
		Cls
		
		counter = TimerTicks(timer)
		
		If skips And gEnd = 1
			DrawText "SPIEL ABGESCHLOSSEN - EINIGE WRTER BERSPRUNGEN",0,0
		ElseIf gEnd = 1
			DrawText "SPIEL ABGESCHLOSSEN - ALLE WRTER GEFUNDEN",0,0
		Else
			DrawText "SPIEL ZUENDE - ZEITLIMIT BERSCHRITTEN",0,0
		EndIf
		
		If counter > 0 Then DrawText "PUNKTESTAND: " + playerpoints,0,32
		If counter > 1 Then DrawText "     ZEITBONUS: +"+ fintime*perfect,0,48
		
		If counter > 2
			DrawText "-------------------------------",0,80
			DrawText "END PUNKTZAHL: " + (playerpoints + fintime*perfect),0,96
			DrawText "DRCKE DIE ESC TASTE ODER EINE MAUSTASTEN",0,128
			DrawText "UM INS MEN ZURCKZUKEHREN",0,144
		EndIf
		
		If KeyHit(KEY_ESCAPE) Or MouseHit(1) Or MouseHit(2) Then Return
		If AppTerminate() Then End
		
		Flip 0
	Forever
End Function

'=================================================

Function DrawField()
	If Not LangWord Then Return
	
	'---------
	
	Local fieldcount:Int = LangWord.FieldArray.Dimensions()[0]
	Local fieldsize:Int = (_GraphicsHeight*0.9)/fieldcount
	
	'---------
	
	Local XPlate:Int = (MouseX()-10) / fieldsize
	Local YPlate:Int = (MouseY()-10) / fieldsize
	If MouseX() < 10 Then XPlate:-1
	If MouseY() < 10 Then YPlate:-1
	
	'---------
	
	Local mhit:Byte = MouseHit(1)
	'Local ShowHelp:Byte = KeyDown(KEY_TAB)
	
	'---------
	
	For Local X:Int = 0 To fieldcount-1
		For Local Y:Int = 0 To fieldcount-1
			DrawChar(Chr(LangWord.FieldArray[X,Y,0]),X,Y,fieldsize)',ShowHelp*LangWord.FieldArray[X,Y,1])
			
			If mhit And X = XPlate And Y = YPlate
				flashtimer = MilliSecs()+700
				flashcolor = 1
				playerpoints:-100
				
				If LangWord.FieldArray[X,Y,1]
					flashcolor = 2
					playerpoints:+LangWord.Difficulty+100
					SelectNextWord()
					Cls
					DrawField()
					Return
				EndIf
			EndIf
		Next
	Next
End Function

'=================================================

Function ReadLangFile:TList(difficulty:Int,difficulty2:Int,maxwords:Int=-1)
	Const LangFile:String = "Language.txt"
	
	Local FileStream:TStream = ReadStream(LangFile)
	If Not FileStream Then RuntimeError "Can't load "+LangFile+"! - EXIT"
	
	LangList = New TList
	While Not Eof(FileStream)
		Local FindWord:TGameWord = TGameWord.Create(ReadString(FileStream,ReadInt(FileStream)))
		If FindWord And (NumBewteen(FindWord.Content.length,difficulty,difficulty2) Or (FindWord.Content.length >= difficulty And difficulty2 = -1)) LangList.AddLast(FindWord)
	Wend
	
	If LangList.IsEmpty() Then RuntimeError LangFile+" is empty! - EXIT"
	
	SelectNextWord()
	
	While (maxwords > 1) And LangList.Count() > maxwords
		SelectNextWord()
	Wend
End Function

Function SelectNextWord()
	If LangWord Then LangList.Remove(LangWord) ; LangWord = Null
	If LangList.IsEmpty() Then Return
	LangWord = TGameWord(LangList.ValueAtIndex(Rand(0,LangList.Count()-1)))
End Function

'=================================================

Function DrawChar(chartext:String,posx:Int,posy:Int,size:Int)',help:Byte=False)
	'If help Then SetColor(128,255,128) Else SetColor(255,255,255)
	
	SetScale(size/74.0,size/74.0)
	DrawImage(Clipboard,10+posx*size,10+posy*size)
	
	SetImageFont(font2)
	
	Local scale:Float = Float(size)/160.0
	SetScale(scale,scale)
	DrawText(chartext,10+posx*size + size/2 - TextWidth(chartext)/2.0*scale,10+posy*size + size/2 - TextHeight(chartext)/2.0*scale)
	SetScale(1,1)
	
	SetImageFont(font1)
End Function

Function DrawClock(time:Int)
	DrawImage(ClockImage,_GraphicsWidth - 220,20)
	
	For Local I:Int = 0 To 2
		SetRotation(Float(time)/roundtime*360.0*(I*60+(I=0)))
		SetScale(1,Float(82-I*10)/82.0)
		DrawImage(CounterArrow,_GraphicsWidth - 120,120)
	Next
	
	SetRotation(0)
	SetScale(1,1)
	
	time:+1000
	
	Local TimeString:String = GetTimeString((time/1000/60) Mod 60) + ":" + GetTimeString((time/1000) Mod 60)
	DrawText(TimeString, _GraphicsWidth - 120 - TextWidth(TimeString)/2,240)
End Function

'=================================================

Function GetTimeString:String(time:Int)
	If time < 10 Then Return "0" + time Else Return time
End Function

Type TGameWord
	Field Content:String
	Field Difficulty:Int
	Field ContainMode:Byte
	Field FieldArray:Byte[,,]
	
	Function Create:TGameWord(Content:String)
		Local ContainMode:Byte = StringContains(Content)
			If ContainMode & 8 Or ContainMode & 16 Then Return Null
			If Content = "" Then Return Null
		
		Local Difficulty:Int = 0
		
		'Schwierigkeitsgrad festellen
			If ContainMode & 1 Then Difficulty:+2 'Kleine Buchstaben sind nicht schwer
			If ContainMode & 2 Then Difficulty:+2 'Groe Buchstaben auch nicht
			If ContainMode & 4 Then Difficulty:+2 'Zahlen sind schwer (finde ich)
			
			If ContainMode & 1 And ContainMode & 2 Then Difficulty:-2 'Verschiedengroe Buchstaben sind einfacher
			If (ContainMode & 1 Or ContainMode & 2) And ContainMode & 4 Then Difficulty:-1 'Buchstaben mit Zahlen sind einfacher
		
		Local GameWord:TGameWord = New TGameWord
			GameWord.Content = Content
			GameWord.Difficulty = Difficulty*Content.length*100
			GameWord.CreateFieldArray()
		
		Return GameWord
	End Function
	
	'Das Spielfeld erstellen
	Method CreateFieldArray(FieldSizeAdd:Int = 3)
		Local FieldSize:Int = Self.Content.length+1 + FieldsizeAdd
		Local ContentContainMode:Byte = StringContains(Content)
		
		Self.FieldArray = New Byte[FieldSize,FieldSize,2]
		
		Local VerticalOrientation:Byte = Rand(0,1)
		Local FieldID:Int = Rand(0,FieldSize-Self.Content.length-1)
		Local FieldID2:Int = Rand(0,FieldSize-1)
		
		Repeat
			'Feld mit Zufallskram fllen
			For Local X:Int = 0 To FieldSize-1
				For Local Y:Int = 0 To FieldSize-1
					Repeat
						FieldArray[X,Y,0] = Rand(32,255)
						FieldArray[X,Y,1] = 0
						
						Local ContainMode:Byte = StringContains(Chr(FieldArray[X,Y,0]))
						
						'Keine Sonderzeichen...
						If ContainMode & 8 Then Continue
						
						'Abfragen ob wir ein invalides Zeichen haben
						Local I:Int = 0
						Repeat
							If ContainMode & Int(2^I) And Not (ContentContainMode & Int(2^I)) Then I = -1 ; Exit
							I:+1 If I = 3 Then I = 5
							If I = 7 Then Exit
						Forever
						If I = -1 Then Continue
						'If ContainMode & 1 And Not (ContentContainMode & 1) Then Continue
						'If ContainMode & 2 And Not (ContentContainMode & 2) Then Continue
						'If ContainMode & 4 And Not (ContentContainMode & 4) Then Continue
						'If ContainMode & 32 And Not (ContentContainMode & 32) Then Continue
						'If ContainMode & 64 And Not (ContentContainMode & 64) Then Continue
						
						Exit
					Forever
				Next
			Next
			
			'Wort einfgen
			For Local I:Int = 0 To Self.Content.length-1
				Local X:Int = FieldID+I
				Local Y:Int = FieldID2
				If VerticalOrientation Then X = FieldID2 ; Y = FieldID+I 'Koordinaten Rotieren fr Wagerechte Ausrichtung
				
				FieldArray[X,Y,0] = Self.Content[I]
				FieldArray[X,Y,1] = 1
			Next
			
			'berprfung
			Local dontregen:Byte = True
			
			For Local I:Int = 0 To FieldSize-1
				Local XString:String = ""
				Local YString:String = ""
				
				Local XCount:Int = 0
				Local YCount:Int = 0
				
				For Local I2:Int = 0 To FieldSize-1
					XString:+Chr(FieldArray[I2,I,0])
					YString:+Chr(FieldArray[I,I2,0])
					
					XCount:+FieldArray[I2,I,1]
					YCount:+FieldArray[I,I2,1]
				Next
				
				If XCount <> Self.Content.length And XString.Contains(Self.Content) Then dontregen = False ; Exit
				If YCount <> Self.Content.length And YString.Contains(Self.Content) Then dontregen = False ; Exit
			Next
			
			If dontregen Then Exit
		Forever
	End Method
End Type

'=================================================

Function NumBewteen:Byte(num:Int,minnum:Int = 0,maxnum:Int = 10)
	If num >= minnum And num <= maxnum Then Return True Else Return False
End Function

Function StringContains:Byte(SearchString:String)
	Const LETTERS:Byte = 1
	Const UPPERLETTERS:Byte = 2
	Const NUMBERS:Byte = 4
	Const SPECIALCHARS:Byte = 8
	Const CONTROLCHARS:Byte = 16
	Const GERMANCHARS:Byte = 32
	Const SPACECHAR:Byte = 64
	
	Local Mode:Int = 0
	
	For Local I:Int = 0 To SearchString.length-1
		Local CharID:Int = SearchString[I]
		If (Not (Mode & LETTERS)) And NumBewteen(CharID,97,122) Then Mode:+LETTERS
		If (Not (Mode & UPPERLETTERS)) And NumBewteen(CharID,65,90) Then Mode:+UPPERLETTERS
		If (Not (Mode & NUMBERS)) And NumBewteen(CharID,48,57) Then Mode:+NUMBERS
		If (Not (Mode & SPECIALCHARS)) And (NumBewteen(CharID,33,47) Or NumBewteen(CharID,58,64) Or NumBewteen(CharID,91,96) Or CharID > 122) And Not (CharID = 196 Or CharID = 228 Or CharID = 214 Or CharID = 246 Or CharID = 220 Or CharID = 252 Or CharID = 223) Then Mode:+SPECIALCHARS
		If (Not (Mode & CONTROLCHARS)) And NumBewteen(CharID,0,31) Then Mode:+CONTROLCHARS
		If (Not (Mode & GERMANCHARS)) And (CharID = 196 Or CharID = 228 Or CharID = 214 Or CharID = 246 Or CharID = 220 Or CharID = 252 Or CharID = 223) Then Mode:+GERMANCHARS
		If (Not (Mode & SPACECHAR)) And CharID = 32 Then Mode:+SPACECHAR
		
		If Mode = 127 Then Return Mode
	Next
	
	Return Mode
End Function